import { Node } from './node';
import { DocumentModel } from '../document-model';
import { IPublicModelModalNodesManager } from '@alilc/lowcode-types';
export declare function getModalNodes(node: Node): any;
export interface IModalNodesManager extends IPublicModelModalNodesManager {
}
export declare class ModalNodesManager implements IModalNodesManager {
    willDestroy: any;
    private page;
    private modalNodes;
    private nodeRemoveEvents;
    private emitter;
    constructor(page: DocumentModel);
    getModalNodes(): Node<import("@alilc/lowcode-types").IPublicTypeNodeSchema>[];
    getVisibleModalNode(): Node<import("@alilc/lowcode-types").IPublicTypeNodeSchema>;
    hideModalNodes(): void;
    setVisible(node: Node): void;
    setInvisible(node: Node): void;
    onVisibleChange(func: () => any): () => void;
    onModalNodesChange(func: () => any): () => void;
    private addNode;
    private removeNode;
    private addNodeEvent;
    private removeNodeEvent;
    setNodes(): void;
}
